#!/usr/bin/python
# -*- coding: utf-8 -*-

__author__ = 'wenbo'

import os
from PyQt4.QtGui import *
from PyQt4.QtCore import *
from switchbutton import SwitchBtn
from utils.enums import AUTOSTART,CRONDAILY
from titlebar import TitleBar
import gettext
gettext.textdomain("kylin-update-manager")

_ = gettext.gettext


class ConfigWidget(QWidget):
    #
    # app_msg = None
    # size_change = pyqtSignal(str, bool)
    m_parent = None

    def __init__(self, parent=None):
        # QWidget.__init__(self,parent)

        super(ConfigWidget,self).__init__(parent)
        self.setFixedSize(336, 230)
        self.parent = parent
        self.setWindowFlags(Qt.FramelessWindowHint|Qt.WindowStaysOnTopHint|Qt.Tool)
        self.setAutoFillBackground(True)
        self.title_bar = TitleBar(self.width(), False, _("Kylin Update Manager config"), self)
        self.title_bar.move(0,0)
        self.title_bar.show()

        self.ui_init()
        self.stylesheet_init()

        self.title_bar.close_button.clicked.connect(self.slot_click_close_button)



    #
    # 函数：初始化ui
    #
    def ui_init(self):
        self.btvalue_init()
        self.bootautocheckbt = SwitchBtn(self,initcheck=self.bootautocheckbt_initchecked) # 开机自动检测按钮
        self.dailycheckbt = SwitchBtn(self,initcheck=self.dailycheckbt_initchecked) # 每日定时检测按钮

        self.bootautochecklabel = QLabel(self)
        self.dailycheclabel = QLabel(self)


    #
    # 函数：初始化样式
    #
    def stylesheet_init(self):
        self.bootautochecklabel.setStyleSheet("QLabel{font-size:14px;color:#666666;}")
        self.bootautochecklabel.setText(_("Boot automatic detection"))
        self.bootautochecklabel.setGeometry(60,70,150,15)

        self.dailycheclabel.setStyleSheet("QLabel{font-size:14px;color:#666666;}")
        self.dailycheclabel.setText(_("Daily timing detection"))
        self.dailycheclabel.setGeometry(60,130,150,15)

        self.bootautocheckbt.setGeometry(220,70,50,24)

        self.dailycheckbt.setGeometry(220,130,50,24)


    #
    # 函数：初始化按钮状态
    #
    def btvalue_init(self):
        if(os.path.exists(AUTOSTART + "kylin-update-manager-autostart.desktop")):
            self.bootautocheckbt_initchecked = True
        else:
            self.bootautocheckbt_initchecked = False


        if(os.path.exists(CRONDAILY + "0kylin-update-manager-daily")):
            self.dailycheckbt_initchecked = True
        else:
            self.dailycheckbt_initchecked = False

    #
    # 函数：关闭按钮响应
    #
    def slot_click_close_button(self):
        self.hide()


    #
    # 函数：鼠标拖动窗口
    #
    def mousePressEvent(self, event):
        if(event.button() == Qt.LeftButton):
            self.mouse_press = True
            self.drag_pos = event.globalPos() - self.pos()
            event.accept()
    def mouseReleaseEvent(self, event):
        self.mouse_press = False
        self.setWindowOpacity(1)
    def mouseMoveEvent(self, event):
        if(self.mouse_press):
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(0.9)
            event.accept()



